/* Copyright (C) 2003 Datapark corp. All rights reserved.
   Copyright (C) 2000-2002 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#include "dps_config.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <ctype.h>

#include "dps_common.h"
#include "dps_wild.h"

#define dps_tolower(c) (tolower(((unsigned char)(c))))

int DpsWildCmp(const char *str, const char *exp)
{
    int x, y;

    for (x = 0, y = 0; exp[y]; ++y, ++x) {
	if ((!str[x]) && (exp[y] != '*'))return -1;
	if (exp[y] == '*') {
	    while (exp[++y] == '*');
	    if (!exp[y])return 0;
	    while (str[x]) {
		int ret;
		if ((ret = DpsWildCmp(&str[x++], &exp[y])) != 1)return ret;
	    }
	    return -1;
	}else
	if ((exp[y] != '?') && (str[x] != exp[y]))return 1;
    }
    return (str[x] != '\0');
}

int __DPSCALL DpsWildCaseCmp(const char *str, const char *exp)
{
    int x, y;

    for (x = 0, y = 0; exp[y]; ++y, ++x) {
	if ((!str[x]) && (exp[y] != '*'))return -1;
	if (exp[y] == '*') {
	    while (exp[++y] == '*');
	    if (!exp[y])return 0;
	    while (str[x]) {
		int ret;
		if ((ret = DpsWildCaseCmp(&str[x++], &exp[y])) != 1)return ret;
	    }
	    return -1;
	}else
	if ((exp[y] != '?') && (dps_tolower(str[x]) != dps_tolower(exp[y])))return 1;
    }
    return (str[x] != '\0');
}
